---
import type { JSX } from "astro/jsx-runtime";

type InputProps = JSX.IntrinsicElements["input"];

interface Props {
  classCustom: string;
  inputProps: InputProps;
  label: string;
}

const { inputProps, label, classCustom } = Astro.props;
---

<div class={`text-lg relative text-sm w-full ${classCustom}`}>
  <input
    {...inputProps}
    class={`
      bg-transparent outline outline-1 outline-neutral-100 focus:outline-2 
      focus:outline-violet-400 text-neutral-100 p-[16px] rounded w-full
    `}
    onfocus="handleFocus(this)"
    onblur="handleBlur(this)"
  />
  <label
    class={`
      bg-neutral-800 absolute text-[16px] top-[14px] left-[12px] text-neutral-200 pointer-events-none 
      font-semibold duration-200 py-[2px] px-[6px]
    `}
  >
    {label}
  </label>
</div>

<style>
  input:-webkit-autofill,
  input:-webkit-autofill:hover,
  input:-webkit-autofill:focus,
  input:-webkit-autofill:active {
    -webkit-background-clip: #fff;
    -webkit-text-fill-color: #fff;
    transition: background-color 5000s ease-in-out 0s;
  }
</style>

<script is:inline>
  function handleBlur(input) {
    const label = Array.from(input.parentNode.childNodes).find(
      (element) => element.nodeName === "LABEL"
    );
    if (input.value) {
      label.classList = `
        bg-neutral-800 absolute text-[14px] top-[-14px] left-[12px] text-neutral-200 pointer-events-none 
        font-semibold duration-200 py-[2px] px-[6px]
      `;
    } else {
      label.classList = `
        bg-neutral-800 absolute text-[16px] top-[14px] left-[16px] text-neutral-200 pointer-events-none 
        font-semibold duration-200 py-[2px] px-[4px]
      `;
    }
  }

  function handleFocus(input) {
    const label = Array.from(input.parentNode.childNodes).find(
      (element) => element.nodeName === "LABEL"
    );
    label.classList = `
      bg-neutral-800 absolute text-[14px] top-[-14px] left-[12px] text-violet-400 pointer-events-none 
      font-semibold duration-200 py-[2px] px-[6px]
    `;
  }
</script>
